Name:           car2txt
Version:        0.06
Release:        2%{?dist}
Summary:        Cmz Ascii Readable (car) files preprocessor and converter

Group:          Development/Libraries
License:        GPLv2+
URL:            http://www.environnement.ens.fr/perso/dumas/mini_ker/software.html
Source0:        http://www.environnement.ens.fr/perso/dumas/mini_ker/car2txt-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:      noarch
BuildRequires:  perl(ExtUtils::MakeMaker)
# fedora specific
#Requires:  perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

%description

Allows extraction from a car file to a directory and files tree and car file
generation from a source tree. Preprocess files with cmz directives.

%prep
%setup -q
cat << \EOF > %{name}-prov
#!/bin/sh
%{__perl_provides} $* |\
sed -e '/perl(Parse::Yapp::Driver)/d'
EOF

%define __perl_provides %{_builddir}/%{name}-%{version}/%{name}-prov
chmod +x %{__perl_provides}


%build
CFLAGS="$RPM_OPT_FLAGS" %{__perl} Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
# specific fedora
#make pure_install PERL_INSTALL_ROOT=$RPM_BUILD_ROOT
# works for mandrake
make pure_install DESTDIR=$RPM_BUILD_ROOT
find $RPM_BUILD_ROOT -type f -name .packlist -exec rm -f {} ';'
find $RPM_BUILD_ROOT -type d -depth -exec rmdir {} 2>/dev/null ';'
chmod -R u+w $RPM_BUILD_ROOT/*


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc README COPYING AUTHORS NEWS COPYING.yapp
%{_bindir}/car2file
%{_bindir}/car2txt
%{_bindir}/file2car
%{perl_vendorlib}/CMZ/
%{_mandir}/man1/*.1*

%changelog
* Fri Dec  1 2006 Patrice Dumas <dumas at centre-cired.fr> 0.06-2
- update to latest version

* Fri Dec  1 2006 Patrice Dumas <dumas at centre-cired.fr> 0.04-2
- initial rpm packaging
