*
* $Id: lenocc.f,v 1.1 2010-02-16 22:14:16 dumas Exp $
*
* $Log: lenocc.f,v $
* Revision 1.1  2010-02-16 22:14:16  dumas
*         * cernlib/*: change .F to .f such that the C preprocessor isn't
*         run on the files.
*         * mini_ker/*: update to 102r.
*         * examples/*: add masselotes example.
*         * */Makefile*: fixes for out of source build.
*         Put mini_ker sources directory within includedir/mini_ker,
*         leading to 3 levels, but it is better since some things may be
*         directly in includedir/mini_ker and are better separated from
*         code directories.
*         * config/mp2a.m4: don't use AC_CACHE*.
*
* Revision 1.1  2007-10-09 21:29:44  dumas
*         * Makefile*, doc/mini_ker.texi, cfs/* scripts/*: update to 102l.
*         * cernlib/*, README: add required cernlib files.
*         * doc/*: add images.
*         * examples/*: more examples.
*
* Revision 1.1.1.1  1996/02/15 17:49:49  mclareni
* Kernlib
*
* Copyright (C) CERN 1984, 1985, 1989, 1996 
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
* 

      FUNCTION LENOCC (CHV)
C
C CERN PROGLIB# M507    LENOCC          .VERSION KERNFOR  4.21  890323
C ORIG. March 85, A.Petrilli, re-write 21/02/89, JZ
C
C-    Find last non-blank character in CHV

      CHARACTER    CHV*(*)

      N = LEN(CHV)

      DO 17  JJ= N,1,-1
      IF (CHV(JJ:JJ).NE.' ') GO TO 99
   17 CONTINUE
      JJ = 0

   99 LENOCC = JJ
      RETURN
      END
