*
* $Id: lvmaxa.f,v 1.1 2010-02-16 22:14:16 dumas Exp $
*
* $Log: lvmaxa.f,v $
* Revision 1.1  2010-02-16 22:14:16  dumas
*         * cernlib/*: change .F to .f such that the C preprocessor isn't
*         run on the files.
*         * mini_ker/*: update to 102r.
*         * examples/*: add masselotes example.
*         * */Makefile*: fixes for out of source build.
*         Put mini_ker sources directory within includedir/mini_ker,
*         leading to 3 levels, but it is better since some things may be
*         directly in includedir/mini_ker and are better separated from
*         code directories.
*         * config/mp2a.m4: don't use AC_CACHE*.
*
* Revision 1.1  2007-10-09 21:29:44  dumas
*         * Makefile*, doc/mini_ker.texi, cfs/* scripts/*: update to 102l.
*         * cernlib/*, README: add required cernlib files.
*         * doc/*: add images.
*         * examples/*: more examples.
*
* Revision 1.1.1.1  1996/02/15 17:50:12  mclareni
* Kernlib
*
* Copyright (C) CERN 1971, 1996 
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
* 
*
      FUNCTION LVMAXA (A,N)
C
C CERN PROGLIB# F121    LVMAXA          .VERSION KERNFOR  1.0   710701
C ORIG. 01/07/71
C
      DIMENSION A(*)
C
C
      IF (N.LE.0)  GO TO 100
      J= 1
      AMAX = 0.
      DO 9 I= 1,N
      CA= ABS (A(I))
      IF (CA.LE.AMAX)  GO TO 9
      AMAX= CA
      J= I
    9 CONTINUE
      LVMAXA = J
      RETURN
  100 LVMAXA = 0
      RETURN
      END
