*CMZ :          07/03/2010  16.02.58  by  Patrice Dumas
*CMZ :          20/02/2005  11.04.55  by  Patrice Dumas
*-- Author :    Patrice Dumas   20/02/2005
C      subroutine ADDBD(BASE,BDIRS,DBDIR,STAT)
      subroutine ADDBD(BASE,DBDIR,STAT)
C      implicit none

CC     ADDBD(BASE,BDIRS,DBDIR,STAT)
C     ADDBD(BASE,BDIRS,STAT)
C     Add a base directories associated with a base name
C     BASE       in   base name
CC     BDIRS      in   structure containing the base directories
CC                     associated with base names (wrongly in common)
C     DBDIR      in   base directory to add
C     STAT       out  status
C                     -1 means that the base names are full
C                     -2 means that the directories associated with
C                     basenames are full.
C                     0 means that everything is right
*KEEP,defpar.
#include "defpar.inc"
*KEND.
*KEEP,mp2cde.
#include "mp2cde.inc"
*KEND.

      integer STAT
      character*(*) base
C      character*(*) BDIRS(NBDRMX,*)
      character*(*) DBDIR
      logical EQSTR
      integer LENSTR
      integer i,j

      STAT = 0
      do 110 i=1,NBDRMX
C        print *, i, ' BDIRS(i,1):', BDIRS(i,1), '!'
C        print *, 'BASE      :', BASE, '!'

        if (LENSTR(BDIRS(i,1)).eq.0) then
          BDIRS(i,1) = BASE
          BDIRS(i,2) = DBDIR
          BDIRS(i,3) = ''//achar(0)
          if (i .lt. NBDRMX) BDIRS(i+1,1) = ''//achar(0)
          return
        end if
        if (EQSTR(BASE, BDIRS(i,1))) then
          do 120 j=2,NDBDMX
            if (LENSTR(BDIRS(i,j)).eq.0) then
              BDIRS(i,j) = DBDIR
              if (j .lt. NDBDMX) BDIRS(i,j+1) = ''//achar(0)
              return
            end if
120        continue
          STAT = -2
          return
        end if
110   continue
      STAT = -1
      end subroutine
