*CMZ :          07/03/2010  16.02.58  by  Patrice Dumas
*CMZ :          20/02/2005  11.04.06  by  Patrice Dumas
*-- Author :    Patrice Dumas   20/02/2005
C      subroutine FINDBD(BASE,BDIRS,DBDIRS,DBNR)
      subroutine FINDBD(BASE,DBDIRS,DBNR)
C      implicit none

C     FINDBD(BASE,DBDIRS,DBNR)
C     Find base directories associated with a base name
C     BASE       in   base name
CC     BDIRS      in   structure containing the base directories
CC                     associated with base names (wrongly in common)
C     DBDIRS     out  array of base directories found
C     DBNR       out  number of base directories found.
C                     -1 means that the base name isn't referenced
C                     0 means that the base name was found but no
C                     directories are associated.
*KEEP,defpar.
#include "defpar.inc"
*KEND.
*KEEP,mp2cde.
#include "mp2cde.inc"
*KEND.

      integer DBNR
      character*(*) base
C      character*(*) BDIRS(NBDRMX,*)
      character*(*) DBDIRS(*)
      logical EQSTR
      integer LENSTR
      integer i,j

      DBNR = -1
C     Find the base name
      do 110 i=1,NBDRMX
C        print *, i, ' BDIRS(i,1):', BDIRS(i,1), '!'
C        print *, 'BASE      :', BASE, '!'
        if (LENSTR(BDIRS(i,1)) .eq. 0) then
          return
        end if
        if (EQSTR(BASE, BDIRS(i,1))) then
C         Return all the base directories associated with that base name
          do 120 j=2,NDBDMX
            DBNR = DBNR + 1
            if (LENSTR(BDIRS(i,j)).eq.0) then
              return
            else
C              print *, 'base dir found for', base, ':', BDIRS(i,j)
              DBDIRS(j-1) = BDIRS(i,j)
            end if
120        continue
          return
        end if
110   continue
      end subroutine
