*CMZ :          07/08/2008  19.40.58  by  Lahellec Alain
*CMZ :  3.07/01 06/08/2008  21.00.13  by  Lahellec Alain
*CMZ :  3.05/07 15/09/94  01.15.24  by  Robert FRANCHISSEUR
*CMZ :  3.05/05 02/05/93  18.29.24  by  Jean-Louis DUFRESNE
*-- Author :    Jean-Louis DUFRESNE   02/05/93
        SUBROUTINE LECTSTR
***************************************************************
*                                                             *
* LECTSTR                                                     *
*                                                             *
*                                                             *
* writen by   : Jean-Louis DUFRESNE, 02/05/93, 14.51.00       *
* modified by :                                               *
***************************************************************
* entree : PIN pointe sur le double cote ouvrant le commentaire
* sortie : PIN pointe sur le double cote fermant le commentaire
*          ou sur le caractere precedent le NUL indiquant qu'il
*          faut lire une nouvelle ligne
C
*KEEP,defpar.
#include "defpar.inc"
*KEND.
C
*KEEP,mp2cde.
#include "mp2cde.inc"
*KEND.
*KEEP,xincde.
#include "xincde.inc"
*KEND.
      integer N,UpCase
c
C     on saute tout les caracteres jusqu'a la fin de ligne ou
C     jusqu'a une deuxieme cote
C ===> Loop
   20 PIN=PIN+1
        N=BIN(PIN)
        XP = XP +1
        if (XP.gt.XPMAX) call ERARE(2,5,3,0)
C       ERROR(6) EXPANSION BUFFER OVERFLOW

C       On range le caractere lu
        X(XP) = N
c Detection de ** (FTN elevation a la puissance) -> MP2 internal StarStar char
c-----------------------------------------------------------------------------
c (le ne Dieze est pour laisser les ** dans un generateur '#* comment')
      if (BIN(1).eq.ET.and.BIN(2).eq.Cote .and. BIN(PIN-1).ne.Dieze
     +      .and. N.eq.Etoile .and. BIN(PIN+1).eq.Etoile) then
c on saute cette deuxieme *
        PIN=PIN+1
c on remplace dans X
        X(XP)=StarStar
      endif
      if ( (N.ne.Cote).and.(N.ne.NUL) ) GO TO 20
C ===> End Loop
c
C     Si fin de ligne
      if (N.eq.NUL) then
C       On enleve le caractere NUL
        XP = XP -1
C       Si on n'autorise pas les chaines de caracteres sur plusieurs lignes
C       et si on ne lit pas une macro
        if (.not.(QFLAG.or.LectMac)) then
C         ERROR(17) UNCLOSED STRING
          call ERARE(3,4,2,0)
C         on ferme les cotes
          XP = XP+1
          X(XP)=Cote
C         On va reanalyser par XIN le caractere NUL. La ligne suivante
C         est ainsi traitee comme une nouvelle ligne normale.
          PIN = PIN-1
C       Si on autorise les chaines de caracteres sur plusieurs lignes
C       ou si on lit une macro
        else
C         caractere suite specifique aux STRING (S)
          CSI=SCH
          CALL MREAD
C         Si fin de fichier
          if (BIN(1).eq.ET.and.BIN(2).eq.ET.and.BIN(3).eq.PTVIRG) then
            call ERARE(3,4,3,0)
C           FATAL ERROR(17) UNCLOSED STRING
C         Si &Q en debut de ligne
          else if (BIN(1).eq.ET.and.UpCase(BIN(2)).eq.Qmaj) then
            call ERARE(3,4,3,0)
C           FATAL ERROR(17) UNCLOSED STRING
          else
            if (LectMac) then
C             Si on est en train de lire une Macro, une ligne ne peut
C             pas commencer par &'
              if(BIN(1).eq.ET.and.BIN(2).eq.Cote) then
                call ERARE(3,6,3,0)
              endif
            endif
          endif
c       on continue a analyser la chaine de caractere
C ====> Go To Loop
        GO TO 20
        endif
C
      endif
C
      return
      end

