*CMZ :  3.05/07 15/09/94  00.07.01  by  Robert FRANCHISSEUR
*CMZ :  3.05/05 03/05/93  15.36.59  by  Jean-Louis DUFRESNE
*CMZ :  3.05/00 11/05/92  19.48.49  by  Jean-Louis DUFRESNE
*-- Author :
C     ===============================================================
      subroutine M2ASC(XX,XXP,DELIM,BB,BBP,BBDIM)
C     ===========================================
C
C     Converti le tableau XX dans le tableau BB,
C     du code MORTRAN au code ASCII. XXP caracteres seront converti
C     (a partir de XX(1)), sauf si on rencontre avant le caractere
C     DELIM. Pour ne pas tester ce caractere de fin, prendre DELIM=255
C     * Variables en argument
C     IN  : XX   : tableau contenant les caracteres en codage interne
C           XXP  : Nombre max de caracteres a convertir
C           DELIM: caractere (codage interne) d'arret
C           BBDIM:Taille max de B
C     OUT : BB   : tableau contenant les carateres ASCCI
C           BBP  : Nombre de caracteres dans ce tableau
C           autres arguments non modifies
C     * Variables globales : OTAB (IN)
C
*KEEP,defpar.
#include "defpar.inc"
*KEND.
*KEEP,mp2cde.
#include "mp2cde.inc"
*KEND.
      integer XX,XXP,DELIM,BB,BBP,BBDIM
      integer T,NXX,BBPMAX,I
      dimension XX(*),BB(*)
C
      BBPMAX = bbp
      BBP=0
      do 100 NXX=1,XXP
        T=XX(NXX)
C       Si delimiteur de fin, on sort
        if (T.eq.DELIM) GO TO 200
        if (T.gt.MIDIM) T=ETOILE
        BBP=BBP+1
        if (BBP.gt.BBDIM) then
          print *,'Error in M2ASC, BBP overflow'
          write(olupr,CARFMT) (BB(I),I=1,BBPMAX)
          go to 200
        endif
  100 BB(BBP)=OTAB(T)
C
  200 return
      end
C
C
