*CMZ :  3.07/00 15/09/98  18.34.44  by  Robert FRANCHISSEUR
*CMZ :  3.05/09 26/02/96  23.40.20  by  Robert FRANCHISSEUR
*CMZ :  3.05/07 15/09/94  01.17.05  by  Robert FRANCHISSEUR
*CMZ :  3.05/06 28/09/93  09.51.58  by  Jean-Louis DUFRESNE
*CMZ :  3.05/05 02/05/93  16.29.56  by  Jean-Louis DUFRESNE
*CMZ :  3.05/00 11/05/92  19.48.48  by  Jean-Louis DUFRESNE
*-- Author :
C     ===============================================================
      SUBROUTINE MREAD
C     ================
C
C     15/2/90    18/09/90
C
*KEEP,defpar.
#include "defpar.inc"
*KEND.
      character*1 MCOMT
      character*2 FCOMT
      parameter (MCOMT='!',FCOMT='C ')
      character*12 SPA12
      parameter (SPA12=' ')
      integer TMPMX
      parameter (TMPMX=CARDIM+12)
      integer UpCase
C     TMPMX : taille max de la chaine de car. temporaire. Pour le 12
C             voir SPA12 et les formats FMT1,FMT2...
      integer NSPAMX
      parameter (NSPAMX=50)
C     MCOMT : carte commentaire de MORTRAN en premiere colonne
C     FCOMT :   "       "          FORTRAN        "
C     SPA12: 12 space character string
C     NSPAMX : Nombre max de blanc autorise lors d'une indantation
C
*KEEP,mp2cde.
#include "mp2cde.inc"
*KEND.
      character*(TMPMX) TMPSTR
C     TMPSTR: temporary string
      integer MSHIFT,LENOCC
      integer PIM,I,J,T,LENSTR
C
C     Si la ligne precedement lue (dans CARD) n'a pas ete affichee
C     (si on n'est pas en mode trace), on l'affiche
C     ------------------------------------------------------------
      IF (PFLAG) GO TO 11
C     Si elle n'a pas ete imprimee, on le fait
      if (IFLAG) then
C       Si on fait de l'indentation
        J = IND*LNL
        if (J.gt.NSPAMX) J=NSPAMX
      else
C       Si on ne fait pas d'indentation
        J=0
      endif
C
      if (NL.eq.LNL) then
C       Si le Nested Level n'a pas change
        write (TMPSTR,FMT1) CSI,(BLANKS(I),I=1,J)
     +           ,(CARD(I),I=1,CARDIM-J)
      else
C       Si le Nested Level a change, on affiche sa valeur
        write (TMPSTR,FMT2)
     +       NL,CSI,(BLANKS(I),I=1,J),(CARD(I),I=1,CARDIM-J)
C       Nouvelle derniere valeur du NL
        LNL = NL
      endif
C
      call AFFICH(TMPSTR)
C
C     On lit une nouvelle ligne
C     --------------------------
C
11    read (INU,LINFMT,END=19) LINSTR
      LENSTR = LENOCC(LINSTR)
C     On supprime les lignes blanches
      if (LENSTR.eq.0) GO TO 11
C     Si la ligne commence par & et que ce n'est pas une macro,
C     on va d'abord voir si c'est une operation sur des fichiers
**-      if (LINSTR(1:1).eq.'&'.and.LINSTR(2:2).ne.1H') then
      if (LINSTR(1:1).eq.'&'.and.LINSTR(2:2).ne.'''') then
        TMPSTR=LINSTR
        call FILMAN(TMPSTR)
C       S'il ne reste pas d'instruction a traiter, on lit une nouvelle ligne
        if (LENOCC(TMPSTR).eq.0) GO TO 11
      endif
C
C     === LIGNE COMMENTAIRE MORTRAN ===
C     Si c'est une ligne commentaire MORTRAN (commence par !), on
C     l'imprime, et on l'enregistre si necessaire, puis on lit la ligne
C     suivante
      if (LINSTR(1:1).eq.MCOMT) then
C       si on doit imprimer la ligne
        if (LFLAG) then
          TMPSTR = SPA12//LINSTR
          call AFFICH(TMPSTR)
        endif
C       si on fait de l'annotation
        if (AFLAG) then
          if (MLTFL) then
C           si la sortie est en MORTRAN
            TMPSTR = MCOMT//LINSTR
          else
C           si la sortie est en FORTRAN
            TMPSTR = FCOMT//LINSTR
          endif
          call WRSTR(OUTU,TMPSTR)
C       fin d'annotation
        endif
C       lecture ligne suivante
        GO TO 11
      endif
C
C     === LIGNE ORDINAIRE ===
C
      if (LENSTR.gt.CARDIM) then
      print *,LINSTR
      print *,'The line above is too long; only ',CARDIM
     +         ,' characters are alowed'
      stop 'In routine MREAD *** ERROR *** ERROR *** ERROR ***'
      endif
C     Convert in Upper Case, if needed
      if (UpCaFl) call CLTOU(LINSTR(1:LENSTR))
C     On lit le tableau d'entier CARD a partir de la chaine LINSTR
      read(LINSTR,CARFMT) CARD
C     On positione le flag indiquant que la ligne doit etre imprimee,
C     le cas echeant
      IF (LFLAG) PFLAG=.FALSE.
C     Si on met des annotations, on ecrit la ligne venant d'etre lue
C     en commentaire FORTRAN ou MORTRAN, dans le fchier de sortie
      if (AFLAG) then
        if (MLTFL) then
C         si la sortie est en MORTRAN
          TMPSTR = MCOMT//LINSTR
        else
C         si la sortie est en FORTRAN
          TMPSTR = FCOMT//LINSTR
        endif
        call WRSTR(OUTU,TMPSTR)
      endif
C
      if (TFLAG.ne.0) then
C       Si on est en mode trace , on affiche tout de suite la ligne lue
C       On affiche le Nested Level et la ligne lue, avec eventuellement
C       un caractere suite
        WRITE (TMPSTR,FMT2) NL,CSI,CARD
        call AFFICH(TMPSTR)
        LNL=NL
        PFLAG=.true.
      endif
C
      PIM=LENSTR
C     On converti les caracteres lus en utilisant la table mortran
C     ITAB. BIN(I) : rang dans la table ITAB.
      DO 13 I=1,PIM
      T=MSHIFT(CARD(I))
   13 BIN(I)=ITAB(T)
C     Dernier caracter = NUL
      BIN(PIM+1)=NUL
      PIN=0
C     Si ce n'est pas un &, return
      IF (BIN(1).NE.ET) RETURN
C     Si c'est une definition de macro (&'), return
      IF (BIN(2).EQ.COTE) RETURN
C     Si ordre (&E)
      if (UpCase(BIN(2)).eq.EMAJ) PFLAG=.TRUE.
      BIN(PIM+1)=PTVIRG
      BIN(PIM+2)=NUL
C     Si ce n'est pas (&F), return
      if (UpCase(BIN(2)).ne.FMAJ) RETURN
C
C     Traitement particulier des lignes "FORTRAN"
C     -------------------------------------------
C     FORTRAN
      LINE=LINE+1
C     Si List Flag, on imprime la ligne precedente
      if (LFLAG) then
        TMPSTR = SPA12//LINSTR
        call AFFICH(TMPSTR)
      endif
C     Si la sortie est en MORTRAN, on ecrit &F sur le fichier de sortie
      if (MLTFL) call WRSTR(OUTU,LINSTR)
C     ==> LOOP lct_ligne_ftn
14    continue
C       lecture ligne suivante
        read (INU,LINFMT,END=19) LINSTR
        if (LENOCC(LINSTR).gt.72) then
          print *,LINSTR
          print *,
     +   '** WARNING ** The FTN line above has more then 72 characters'
        endif
C       si on doit afficher cette ligne
        if (LFLAG) then
          TMPSTR=SPA12//LINSTR
          call AFFICH(TMPSTR)
        endif
C       ==> EXIT LOOP lct_ligne_ftn
        if ((LINSTR(1:2).eq.'&M').or.(LINSTR(1:2).eq.'&m')) go to 15
C       on enregistre la ligne FORTRAN venant d'etre lue, telle que.
        call WRSTR(OUTU,LINSTR)
C     ==> END LOOP lct_ligne_ftn
      go to 14
C
C     On viend de lire &M; on l'enregistre si necessaire
15    if (MLTFL) call WRSTR(OUTU,LINSTR)
c     lecture ligne suivante
      GO TO 11
C
C     Fin de fichier
C     --------------
C
   19 BIN(1)=ET
      BIN(2)=ET
      BIN(3)=PTVIRG
      BIN(4)=NUL
      PIN=0
      PFLAG=.TRUE.
      RETURN
C
      END
C
