*CMZ :          07/08/2008  20.05.48  by  Lahellec Alain
*CMZ :  3.07/01 06/08/2008  21.09.00  by  Lahellec Alain
*CMZ :  3.05/08 31/07/95  17.56.09  by  Alain LAHELLEC
*CMZ :  3.05/07 27/07/95  21.01.17  by  Alain LAHELLEC
*CMZ :  3.05/05 03/05/93  15.53.18  by  Jean-Louis DUFRESNE
*CMZ :  3.05/00 11/05/92  19.48.48  by  Jean-Louis DUFRESNE
*-- Author :
C     ===============================================================
      SUBROUTINE XIN
c     ==============
c
c
C     02/5/93 : reecriture complete
C     15/2/89
C
C     Lecture d'une instruction MORTRAN.
C     On rempli "l'expansion buffer" X jusqu'au premier ; a partir des
C     caracteres contenus dans le buffer BIN. Celui-ci contiend des
C     caracteres qui sont lus et convertis en codage interne par READ
C
*KEEP,defpar.
#include "defpar.inc"
*KEND.
C
*KEEP,mp2cde.
#include "mp2cde.inc"
*KEND.
*KEEP,xincde.
#include "xincde.inc"
*KEND.
      LOGICAL ALFANU
      integer N
c
c     On imprime, si il y en a, des User message
      call PrUsEr
c
      LectMac = .false.
      XP=XPBREF
      X(XP)=PTVIRG
C
C     Boucle de base de lecture de caractere dans BIN et d'ecriture dans X
C     -------------------------------------------------------------------
C
C     ==> LOOP lect_car
11    continue
C       Si on vient de lire une ligne
        if (PIN.eq.0) then
C         on regarde si on vient de lire une macro
          if (BIN(1).eq.ET.and.BIN(2).eq.Cote) then
C           Si il y avait quelque chose avant la macro qui vient d'etre lue,
C           on ajoute un ; et on demande a MORTRAN de l'interpreter
            if ( XP .ne. XPBref) then
              XP = XP +1
              X(XP) = PtVirg
C ==          ==> EXIT lect_car
              GO TO 19
            else
              LectMac = .true.
C *****   FAUX *****
C ==        LectMac est mis a faux par MP2, lorsqu'il y a definition
C ==        de macro
            endif
          endif
        endif
c
C       On lit le caractere suivant dans BIN
        PIN = PIN+1
        N = BIN(PIN)
        if (XP.gt.XPMAX) call ERARE(2,5,3,0)
C       ERROR(6) EXPANSION BUFFER OVERFLOW
        XP = XP +1
C       On range le caractere lu
        X(XP) = N
C
C       ==> EXIT lect_car
C==     La sortie de boucle se fait si c'est un ; ==
        if (N.eq.PTVIRG) GO TO 19
c
C==     Si c'est le caractere "NUL", lit la ligne suivante(a la recherche du ;)
        if (N.eq.NUL) then
C         On supprime ce caractere
          XP = XP -1
C         Il n'y a pas de caractere de continuation de ligne
          CSI=SPACE
          call MREAD
c Detection de ** (FTN elevation a la puissance) -> MP2 internal starstar char
c-----------------------------------------------------------------------------
        elseif (N.eq.Etoile .and. BIN(PIN+1).eq.Etoile) then
c on saute cette deuxieme *
          PIN=PIN+1
c on remplace dans X
          X(XP)=StarStar
c
c==     Si double cotes
        else if(N.eq.DblCot) then
C         Si deux doubles cotes de suite, on en garde 1
          if (BIN(PIN+1).eq.DBLCOT) then
             PIN = PIN +1
          else
C           On supprime ce caractere
            XP = XP -1
c           Si double cotes, on supprime les commentaires. Au retour PIN
C           point sur le double cote fermant le commentaire, ou sur NUL
c           s'il faut relire une ligne
            call LectCmt
          endif
C
C==     Si ouverture d'un block, on increment le Nesting Level counter
        else if (N.eq.INF.and..not.BFLAG) then
          NL = NL+1
C==     Si >, on ajoute un ; avant
        else if (N.eq.SUP.and..not.BFLAG) then
          X(XP)=PTVIRG
C==       Si deux > se suivent, on considere que c'est une intruction
C         complete et on lance MORTRAN avant le deuxieme >
          if ( X(XP-1).eq.Sup ) then
C           Il faudra reanalyser ce deuxieme caractere >
            PIN = PIN -1
C ==        ==> EXIT lect_car
            go to 19
          endif
C==       Si >, on decremente le Nesting Level counter, sauf s'il n'y
C         a pas de block a fermer
          NL = NL-1
          if (NL.lt.0) then
            call ERARE(3,2,2,0)
            NL = 0
          else
            XP=XP+1
            X(XP)=SUP
          endif
C==     traitement des espaces (sauf si &B set)
        else if (N.eq.BLANC.and..not.BFLAG) then
   13     PIN=PIN+1
            N=BIN(PIN)
C         on ne garde qu'un seul espace
          if (N.eq.BLANC) go to 13
C         Si on n'est pas entre deux caracteres alphanumeriques, on
C         supprime cet espace
          if ( .not. ( ALFANU(X(XP-1)).and.ALFANU(N) )) XP=XP-1
C         il faut reanalyser le caractere lu
          PIN = PIN -1
C
C==     traitement des chaines de caracteres
        else if (N.eq.Cote.and..not.BFLAG) then
          call LectStr
        end if
C
      GO TO 11
C     ==> END LOOP lect_car
C
C     Fin du remplissage de X (; rencontre)
C     -------------------------------------
C
C     END OF STATEMENT CHARACTER
   19 IF (XPMAX.LE.XP) CALL ERARE(2,5,3,0)
C     La suite de caracteres transmise a X se termine par un NUL
      X(XP+1)=NUL
C     Store instruction in Y, and make some chek
      call ChkIns
      RETURN
      END
c
