*
* $Id: spaces.f,v 1.1 2010-02-16 22:14:16 dumas Exp $
*
* $Log: spaces.f,v $
* Revision 1.1  2010-02-16 22:14:16  dumas
*         * cernlib/*: change .F to .f such that the C preprocessor isn't
*         run on the files.
*         * mini_ker/*: update to 102r.
*         * examples/*: add masselotes example.
*         * */Makefile*: fixes for out of source build.
*         Put mini_ker sources directory within includedir/mini_ker,
*         leading to 3 levels, but it is better since some things may be
*         directly in includedir/mini_ker and are better separated from
*         code directories.
*         * config/mp2a.m4: don't use AC_CACHE*.
*
* Revision 1.1  2007-10-09 21:29:44  dumas
*         * Makefile*, doc/mini_ker.texi, cfs/* scripts/*: update to 102l.
*         * cernlib/*, README: add required cernlib files.
*         * doc/*: add images.
*         * examples/*: more examples.
*
* Revision 1.2  2002/03/04 16:20:46  mclareni
* Tidy a dubious construct which fails with Sun WS6U1 f77 at opt 3
*
* Revision 1.1.1.1  1996/02/15 17:47:49  mclareni
* Kernlib
*
*
* Copyright (C) CERN 1986, 1989, 1996, 2002
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
* 

*
      CHARACTER*(*) FUNCTION SPACES(STR,MSPACE)
C
C CERN PROGLIB# M433    SPACES          .VERSION KERNFOR  4.14  860211
C ORIG.  6/05/86 M.GOOSSENS/DD
C
C-    The function value SPACES returns the character string STR with
C-    leading blanks removed and each occurence of one or more blanks
C-    replaced by NSPACE blanks inside the string STR
C
      CHARACTER*(*) STR
C
      NSPACE = MSPACE
      LENSPA = LEN(SPACES)
      SPACES = ' '
      IF (NSPACE.LT.0) NSPACE = 0
      IBLANK = 1
      ISPACE = 1
  100 INONBL = INDEXC(STR(IBLANK:),' ')
      IF (INONBL.EQ.0) THEN
          SPACES(ISPACE:) = STR(IBLANK:)
                                                    GO TO 999
      ENDIF
      INONBL = INONBL + IBLANK - 1
      IBLANK = INDEX(STR(INONBL:),' ')
      IF (IBLANK.EQ.0) THEN
          SPACES(ISPACE:) = STR(INONBL:)
                                                    GO TO 999
      ENDIF
      IBLANK = IBLANK + INONBL - 1
      SPACES(ISPACE:) = STR(INONBL:IBLANK-1)
      ISPACE = ISPACE + IBLANK - INONBL + NSPACE
      IF (ISPACE.LE.LENSPA)                         GO TO 100
  999 END
