%if 0%{?rhel}
%if "%rhel" <= "4"
%define g77_compiler 1
%endif
%endif

Name:           mp2a 
Version:        3.07.01.1
Release:        2%{?dist}
Summary:        Fortran preprocessor and macro language

Group:          Development/Languages
License:        GPL
URL:            http://www.environnement.ens.fr/perso/dumas/mini_ker/software.html
Source0:        http://www.environnement.ens.fr/perso/dumas/mini_ker/mp2a-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

# mdk
#BuildRequires:  gcc-g77
%if 0%{?g77_compiler}
BuildRequires:   /usr/bin/g77
%else
BuildRequires: gcc-gfortran
%endif
BuildRequires: car2txt
Requires(post):  /sbin/install-info
Requires(preun): /sbin/install-info


%description

Mortran is a fortran preprocessor and a macro language. It comes with
standard macros enabling to write structured code in free form, while
still producing fortran 77. The macro capabilities enables unlimited
extensions.

%prep
%setup -q


%build
# flags for g77:
# remove -mtune as g77 doesn't know that option
# remove also --param=ssp-buffer-size=4 and  -fstack-protector
#export FFLAGS="-O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -m32 -march=i386 -fasynchronous-unwind-tables"

%if ! 0%{?g77_compiler}
export F77=gfortran
%endif
%configure
make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT


%check
make check


%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/install-info %{_infodir}/mortran.info %{_infodir}/dir || :

%preun
if [ $1 = 0 ]; then
    /sbin/install-info --delete %{_infodir}/mortran.info %{_infodir}/dir || :
fi

%files
%defattr(-,root,root,-)
%doc README NEWS AUTHORS COPYING mortran.pdf
%{_bindir}/mortran
%{_bindir}/mtn
%{_bindir}/mtndepend
%dir %{_prefix}/exe
%{_prefix}/exe/mtn.exe
%{_infodir}/mortran.*
%dir %{_datadir}/mp2a
%{_datadir}/mp2a/mtn.mac
%dir %{_prefix}/mac
%{_prefix}/mac/mtn.mac
%dir %{_datadir}/aclocal
%{_datadir}/aclocal/mp2a.m4

%changelog
* Mon Dec  8 2008 Patrice Dumas <dumas at centre-cired.fr> - 3.07.01.1-2
- update to 3.07.01.1

* Mon Jul 24 2006 Patrice Dumas <dumas at centre-cired.fr> - 3.07.00.7-2
- update to 3.07.00.7
- use gfortran
- add conditionals for rhel

* Mon Jul 24 2006 Patrice Dumas <dumas at centre-cired.fr> - 3.07.00.1-1
- update to 3.07.00.1

* Wed Jun 08 2005 Patrice Dumas <dumas at centre-cired.fr> - 3.07.00-1
- initial rpm packaging
