*CMZ :  3.05/07 27/07/95  20.19.07  by  Alain LAHELLEC
*CMZ :  3.05/06 09/02/94  22.32.09  by  Alain LAHELLEC
*CMZ :  3.05/05 03/05/93  15.48.58  by  Jean-Louis DUFRESNE
*CMZ :  3.05/04 24/02/93  18.26.50  by  Jean-Louis DUFRESNE
*CMZ :  3.05/01 11/05/92  20.02.15  by  Jean-Louis DUFRESNE
*CMZ :  3.05/00 11/05/92  19.48.48  by  Jean-Louis DUFRESNE
*-- Author :
C
C     ===== PARAMETER =====
C
C     LLCTMX : Longeur max d'une ligne en lecture = longeur max autorisee
C              + un pied de pilote pour pouvoir dire si une ligne lue
C              est trop longue
C     NPMAX  : nombre max de parametres d'une macro plus apparement
C              une autre fonction dans MP2, "OPERATORS IN MACRO"
C     SPMAX  : apparement, "profondeur" maximum d'un stack
C     NSTPMX : Nombre max de stack pointer ; verifier la coherence avec
C              le format 1002 dans MP2 et avec CCA (a ne pas modifier)
C     MPMAX, XPMAX, PPMAX : Valeur a de pas depacer pour les pointeurs
C              des tableaux M, X et P . Inferieur a la dimension des tableaux
C              apparement pour avoir un pied de pilote
C     xxDIM  : dimension du tableau xx
C     CARDIM : longueur max d'une ligne en entree (et egalement
C              celle de la sortie "lising")
C     BOUDIM : longueur max d'une ligne dans le fichier de sortie
C     NINUMX : Nombre max d'unite de lecture ouvrable en meme temps
C     KCHMX  : Longeur max de nom de fichiers (attention il reste
C              quelques format A200)
C     NBDRMX : Nombre max de repertoire de base
C     NDBDMX : Nombre max de repertoire possible par repertoire de base
C     LBDMX  : Longeur max de nom de repertoire de base
C     NERRMX : nombre max d'erreur MORTRAN avant arret
C     NWARMX : idem avec warning
C     XPBREF : Point "milieu" de l'expansion buffer X. Les caracters lus sont
C              ranges dans X a partir de XPBREF. Les caracters remplaces sont
C              ranges dans X a partir de 1 ; ils peuvent depacer XPBREF et
C              ecraser les premiers mots lus, deja remplacees.
C
C     ===== VARIABLES DU COMMON /B/ =====
C
C     M         MACRO BUFFER
C     X         EXPANSION BUFFER
C     P         PARAMETER BUFFER
C     MP        MACRO POINTER
C     XP        EXPANSION POINTER
C     XPCOTE    EXPANSION POINTER BEGINING A STRING
C     XPCMT     EXPANSION POINTER BEGINING A COMMENT
C     PP        PARAMETER POINTER
C     NP        NUMBER OF PARAMETERS
C     PN        PARAMETER NUMBER
C     S         STACK
C     SP        STACK POINTER
C     STP(T)    STACK POINTERS
C     MPB       MACRO POINTER BASE
C     XPB       EXPANSION POINTER BASE
C     RP        REPLACEMENT POINTER
C     RPB       REPLACEMENT POINTER BASE
C     OP        OUTPUT POINTER
C     PIN       INPUT POINTER
C     POUT      OUTPUT POINTER
C     FSP       FREE SPACE POINTER
C     FSPB
C     STN       STATEMENT NUMBER
C     MPMAX     MAXIMUM MACRO POINTER
C     XPMAX     MAXIMUM EXPANSION POINTER
C     PPMAX     MAXIMUM PARAMETER POINTER
C     B         BUFFER
C     BIN       INPUT BUFFER
C     CARD      Derniere ligne lue compose de caracters codes dans des entiers
C     LINSTR    chaine de caracter de la ligne venant d'etre lue
C               (chaine parallele au tableau d'entier CARD)
C     BOUT      OUTPUT BUFFER
C     TITLE     Titre defini par #T, imprime en debut de page et lors de chaque
C     CARFMT    Format pour pour lecture de CARD et ecriture sur listing
C     LINFMT    Format de lecture d'une ligne (un peu + grand que CARFMT
C               pour securite)
C     BOUFMT    Format pour ecriture sur fichier
C     ITAB      INPUT CHARACTER TABLE
C     OTAB      OUTPUT CHARACTER TABLE
C     INU       INPUT UNIT
C     INUNBR    Stack pointer des numero des unites d'entree
C     INUNAM    idem, pour les nom
C     INUSTK    Pointeur de l'unite utilise dans INUNBR et INUNAM
C     INUOPN    Numero d'unite du prochain open, quand on utilise &Ufile_name
C     OUTU      OUTPUT UNIT
C     OLUPR     std output PRinter        6
C     OLUERR    std ERRors
C     NERR      NUMBER OF ERRORS
C     NWARN     NUMBER OF WARNINGS
C     NTERR     TOTAL NUMBER OF ERRORS
C     NTWARN    TOTAL NUMBER OF WARNINGS
C     NL        NESTING LEVEL
C     LNL       LAST NESTING LEVEL (cf. READ)
C     IND       Nombre de blanc genere par NESTING LEVEL
C     CSI       COMMENT OR STRING INDICATOR
C     AFLAG     ANNOTATION FLAG
C     BFLAG     Vrai: Supprime le traitement des blancs en trop.
C     EFLAG     ERROR FLAG
C     FFLAG     FLAG TRUE UNTIL A CHARACTER IS NOT WRITE ON OUTPUT
C     HFLAG     Vrai si les chaines de caracteres sont converties en Hollerith
C     IFLAG     IDENTATION FLAG
C     LFLAG     LIST FLAG
C     MLTFL     MULTI PASSE FLAG
C     PFLAG     Vrai si la ligne lue a deja ete imprime
C     QFLAG     QUOTE FLAG
C     SFLAG     SUPPRESSES PARENTHESIS CHECKS
C     TFLAG     TRACE FLAG
C     UpCaFl     Convert in Upper Case Flag
C     BLANKS    LINE WITH SPACE CHARATERS ONLY, IN MORTRAN CODE
C     PAGE      NUMERO DE LA PAGE SUR LAQUELLE ON ECRIT
C     LINE      NOMBRE DE LIGNE DEJA IMPRIME SUR LA PAGE
C     MLINE     NOMBRE MAX DE LIGNE A IMPRIMER SUR UNE PAGE
C     BDIRS     structure associant prefixes de fichiers et repertoires
C
