#! /bin/sh

mini_ker_dir=../mini_ker-102
mp2a_dir=../mp2a
car2txt_dir=../car2txt
mini_ker_ver=1.02.00.7
mp2a_ver=3.07.01.1
car2txt_ver=0.06

mini_ker_tar=mini_ker-$mini_ker_ver.tar.gz
mp2a_tar=mp2a-$mp2a_ver.tar.gz
car2txt_tar=car2txt-$car2txt_ver.tar.gz

rm -rf car2txt* mini_ker* mp2a*
cp $mini_ker_dir/$mini_ker_tar $mini_ker_dir/doc/mini_ker.pdf .
cp $mp2a_dir/$mp2a_tar .
cp $car2txt_dir/$car2txt_tar .

for file in $mini_ker_tar $mp2a_tar $car2txt_tar; do
tar xzf $file
rm $file
done

sed -e "s/@mini_ker_ver@/$mini_ker_ver/" \
 -e "s/@mp2a_ver@/$mp2a_ver/" \
 -e "s/@car2txt_ver@/$car2txt_ver/" \
  Makefile.in > Makefile

cd .. && rm -f self_mini_ker.tar.gz && tar czvf self_mini_ker.tar.gz self_mini_ker
